local function piercevisual(mo)
	if mo.pierce and leveltime%2
		local g = P_SpawnGhostMobj(mo)
		if g and g.valid
			g.color = SKINCOLOR_RED
			g.colorized = true
			g.destscale = $ * 2
		end
	end
end
for i = MT_RS_SHOT, MT_RS_THROWNINFINITY
	addHook("MobjThinker", piercevisual, i)
end

local function dofuse(mo)
	if mo.lifetime == nil
		return
	end
	mo.lifetime = $ - 1
	if mo.lifetime == 0
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		S_StopSoundByID(mo, sfx_s3kc6l)
		P_ExplodeMissile(mo)
		return
	end
	if mo.lifetime > 0 and mo.lifetime % 12 == 0 and mo.info.attacksound
		S_StartSound(mo, mo.info.attacksound)
	end
end

addHook("MobjThinker", dofuse, MT_RS_THROWNBOUNCE)
addHook("MobjThinker", dofuse, MT_RS_THROWNSCATTER)
addHook("MobjThinker", dofuse, MT_RS_THROWNGRENADE)
addHook("MobjThinker", dofuse, MT_RS_THROWNSEEKER)

local function dorocketjump(mo)
	if mo.state != S_RINGEXPLODE return end
	for player in players.iterate
		if player.playerstate != PST_LIVE or not (player.mo and player.mo.valid)
			return
		end
		local pmo = player.mo
		local diffx = pmo.x - mo.x
		local diffy = pmo.y - mo.y
		local diffz = (pmo.z + pmo.height/2) - mo.z
		local distxy = R_PointToDist2(0, 0, diffx, diffy)
		local xyang = R_PointToAngle2(0, 0, diffx, diffy)
		local zang = R_PointToAngle2(0, 0, distxy, diffz)
		local dist = R_PointToDist2(0, 0, distxy, diffz)
		local maxdist = 192*FRACUNIT
		local strength = 20
		if dist <= maxdist and mo.target == player.mo
			S_StartSoundAtVolume(pmo, sfx_beflap, 120)
			local force = FixedMul(mo.scale, min(FRACUNIT, FRACUNIT*8/7 - (dist/192))) * strength
			local thrustxy = P_ReturnThrustX(nil, zang, force)
			local thrustz = P_ReturnThrustY(nil, zang, force) * 3/4
			P_Thrust(pmo, xyang, thrustxy)
			pmo.momz = $ + thrustz
		end
	end
end

addHook("MobjThinker", dorocketjump, MT_RS_THROWNGRENADE)
addHook("MobjThinker", dorocketjump, MT_RS_THROWNEXPLOSION)

addHook("MobjThinker", function(mo)
	if mo.state < mo.info.spawnstate or mo.state > S_RS_THROWNSEEKER7
		return
	end
	if not (mo.target and mo.target.valid and mo.target.player and mo.target.player.playerstate == PST_LIVE)
		return
	end
	
	local player = mo.target.player
	local pmo = mo.target
	P_Thrust(mo, pmo.angle, 6*FRACUNIT)
	mo.momx = $ * 9/10
	mo.momy = $ * 9/10
	mo.angle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	P_SetObjectMomZ(mo, player.aiming / 10000, true)
	mo.momz = min(15*FRACUNIT, max($, -15*FRACUNIT))
	mo.momz = $ * 12/13
	
	if mo.state == mo.info.spawnstate
		P_SpawnGhostMobj(mo).destscale = $*2
	end
end, MT_RS_THROWNSEEKER)

addHook("MobjSpawn", function(mo)
	S_StartSoundAtVolume(mo, sfx_s3kc6l, 50)
end, MT_RS_THROWNSEEKER)

addHook("MobjSpawn", function(mo)
	mo.state = $ + P_RandomRange(0, 6)
end, MT_RS_THROWNAUTOMATIC)